# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`patroni`](#patroni): Manages a Patroni instance

### Resource types

* [`patroni_dcs_config`](#patroni_dcs_config): Manages Patroni DCS configuration options
* [`patronictl_config`](#patronictl_config): Abstract type to configure other types

## Classes

### <a name="patroni"></a>`patroni`

Manages a Patroni instance

#### Parameters

The following parameters are available in the `patroni` class:

* [`scope`](#scope)
* [`namespace`](#namespace)
* [`hostname`](#hostname)
* [`dcs_loop_wait`](#dcs_loop_wait)
* [`dcs_ttl`](#dcs_ttl)
* [`dcs_retry_timeout`](#dcs_retry_timeout)
* [`dcs_maximum_lag_on_failover`](#dcs_maximum_lag_on_failover)
* [`dcs_master_start_timeout`](#dcs_master_start_timeout)
* [`dcs_synchronous_mode`](#dcs_synchronous_mode)
* [`dcs_synchronous_mode_strict`](#dcs_synchronous_mode_strict)
* [`dcs_postgresql_use_pg_rewind`](#dcs_postgresql_use_pg_rewind)
* [`dcs_postgresql_use_slots`](#dcs_postgresql_use_slots)
* [`dcs_postgresql_recovery_conf`](#dcs_postgresql_recovery_conf)
* [`dcs_postgresql_parameters`](#dcs_postgresql_parameters)
* [`bootstrap_method`](#bootstrap_method)
* [`initdb_data_checksums`](#initdb_data_checksums)
* [`initdb_encoding`](#initdb_encoding)
* [`initdb_locale`](#initdb_locale)
* [`bootstrap_pg_hba`](#bootstrap_pg_hba)
* [`bootstrap_users`](#bootstrap_users)
* [`bootstrap_post_bootstrap`](#bootstrap_post_bootstrap)
* [`bootstrap_post_init`](#bootstrap_post_init)
* [`superuser_username`](#superuser_username)
* [`superuser_password`](#superuser_password)
* [`replication_username`](#replication_username)
* [`replication_password`](#replication_password)
* [`callback_on_reload`](#callback_on_reload)
* [`callback_on_restart`](#callback_on_restart)
* [`callback_on_role_change`](#callback_on_role_change)
* [`callback_on_start`](#callback_on_start)
* [`callback_on_stop`](#callback_on_stop)
* [`pgsql_connect_address`](#pgsql_connect_address)
* [`pgsql_create_replica_methods`](#pgsql_create_replica_methods)
* [`pgsql_data_dir`](#pgsql_data_dir)
* [`pgsql_config_dir`](#pgsql_config_dir)
* [`pgsql_bin_dir`](#pgsql_bin_dir)
* [`pgsql_listen`](#pgsql_listen)
* [`pgsql_use_unix_socket`](#pgsql_use_unix_socket)
* [`pgsql_pgpass_path`](#pgsql_pgpass_path)
* [`pgsql_recovery_conf`](#pgsql_recovery_conf)
* [`pgsql_custom_conf`](#pgsql_custom_conf)
* [`pgsql_parameters`](#pgsql_parameters)
* [`pgsql_pg_hba`](#pgsql_pg_hba)
* [`pgsql_pg_ctl_timeout`](#pgsql_pg_ctl_timeout)
* [`pgsql_use_pg_rewind`](#pgsql_use_pg_rewind)
* [`pgsql_remove_data_directory_on_rewind_failure`](#pgsql_remove_data_directory_on_rewind_failure)
* [`pgsql_replica_method`](#pgsql_replica_method)
* [`manage_postgresql_repo`](#manage_postgresql_repo)
* [`use_consul`](#use_consul)
* [`consul_host`](#consul_host)
* [`consul_url`](#consul_url)
* [`consul_port`](#consul_port)
* [`consul_scheme`](#consul_scheme)
* [`consul_token`](#consul_token)
* [`consul_verify`](#consul_verify)
* [`consul_register_service`](#consul_register_service)
* [`consul_service_check_interval`](#consul_service_check_interval)
* [`consul_consistency`](#consul_consistency)
* [`consul_cacert`](#consul_cacert)
* [`consul_cert`](#consul_cert)
* [`consul_key`](#consul_key)
* [`consul_dc`](#consul_dc)
* [`consul_checks`](#consul_checks)
* [`use_etcd`](#use_etcd)
* [`etcd_host`](#etcd_host)
* [`etcd_hosts`](#etcd_hosts)
* [`etcd_url`](#etcd_url)
* [`etcd_proxyurl`](#etcd_proxyurl)
* [`etcd_srv`](#etcd_srv)
* [`etcd_protocol`](#etcd_protocol)
* [`etcd_username`](#etcd_username)
* [`etcd_password`](#etcd_password)
* [`etcd_cacert`](#etcd_cacert)
* [`etcd_cert`](#etcd_cert)
* [`etcd_key`](#etcd_key)
* [`use_exhibitor`](#use_exhibitor)
* [`exhibitor_hosts`](#exhibitor_hosts)
* [`exhibitor_poll_interval`](#exhibitor_poll_interval)
* [`exhibitor_port`](#exhibitor_port)
* [`use_kubernetes`](#use_kubernetes)
* [`kubernetes_namespace`](#kubernetes_namespace)
* [`kubernetes_labels`](#kubernetes_labels)
* [`kubernetes_scope_label`](#kubernetes_scope_label)
* [`kubernetes_role_label`](#kubernetes_role_label)
* [`kubernetes_use_endpoints`](#kubernetes_use_endpoints)
* [`kubernetes_pod_ip`](#kubernetes_pod_ip)
* [`kubernetes_ports`](#kubernetes_ports)
* [`restapi_ciphers`](#restapi_ciphers)
* [`restapi_connect_address`](#restapi_connect_address)
* [`restapi_listen`](#restapi_listen)
* [`restapi_username`](#restapi_username)
* [`restapi_password`](#restapi_password)
* [`restapi_certfile`](#restapi_certfile)
* [`restapi_keyfile`](#restapi_keyfile)
* [`restapi_cafile`](#restapi_cafile)
* [`restapi_verify_client`](#restapi_verify_client)
* [`use_zookeeper`](#use_zookeeper)
* [`zookeeper_hosts`](#zookeeper_hosts)
* [`watchdog_mode`](#watchdog_mode)
* [`watchdog_device`](#watchdog_device)
* [`watchdog_safety_margin`](#watchdog_safety_margin)
* [`manage_postgresql`](#manage_postgresql)
* [`postgresql_version`](#postgresql_version)
* [`package_name`](#package_name)
* [`version`](#version)
* [`install_dependencies`](#install_dependencies)
* [`manage_python`](#manage_python)
* [`install_method`](#install_method)
* [`install_dir`](#install_dir)
* [`python_class_version`](#python_class_version)
* [`python_venv_version`](#python_venv_version)
* [`config_path`](#config_path)
* [`config_owner`](#config_owner)
* [`config_group`](#config_group)
* [`config_mode`](#config_mode)
* [`service_name`](#service_name)
* [`service_ensure`](#service_ensure)
* [`service_enable`](#service_enable)
* [`custom_pip_provider`](#custom_pip_provider)

##### <a name="scope"></a>`scope`

Data type: `String`

Refer to Patroni Global `scope` setting

##### <a name="namespace"></a>`namespace`

Data type: `String`

Refer to Patroni Global `namespace` setting

Default value: `'/service/'`

##### <a name="hostname"></a>`hostname`

Data type: `String`

Refer to Patroni Global `name` setting

Default value: `$facts['networking']['hostname']`

##### <a name="dcs_loop_wait"></a>`dcs_loop_wait`

Data type: `Integer`

Refer to Patroni Dynamic Configuration Settings `loop_wait` setting

Default value: `10`

##### <a name="dcs_ttl"></a>`dcs_ttl`

Data type: `Integer`

Refer to Patroni Dynamic Configuration Settings `ttl` setting

Default value: `30`

##### <a name="dcs_retry_timeout"></a>`dcs_retry_timeout`

Data type: `Integer`

Refer to Patroni Dynamic Configuration Settings `retry_timeout` setting

Default value: `10`

##### <a name="dcs_maximum_lag_on_failover"></a>`dcs_maximum_lag_on_failover`

Data type: `Integer`

Refer to Patroni Dynamic Configuration Settings `maximum_lag_on_failover` setting

Default value: `1048576`

##### <a name="dcs_master_start_timeout"></a>`dcs_master_start_timeout`

Data type: `Integer`

Refer to Patroni Dynamic Configuration Settings `master_start_timeout` setting

Default value: `300`

##### <a name="dcs_synchronous_mode"></a>`dcs_synchronous_mode`

Data type: `Boolean`

Refer to Patroni Dynamic Configuration Settings `synchronous_mode` setting

Default value: ``false``

##### <a name="dcs_synchronous_mode_strict"></a>`dcs_synchronous_mode_strict`

Data type: `Boolean`

Refer to Patroni Dynamic Configuration Settings `synchronous_mode_strict` setting

Default value: ``false``

##### <a name="dcs_postgresql_use_pg_rewind"></a>`dcs_postgresql_use_pg_rewind`

Data type: `Boolean`

Refer to Patroni Dynamic Configuration Settings `postgresql_use_pg_rewind` setting

Default value: ``true``

##### <a name="dcs_postgresql_use_slots"></a>`dcs_postgresql_use_slots`

Data type: `Boolean`

Refer to Patroni Dynamic Configuration Settings `postgresql_use_slots` setting

Default value: ``true``

##### <a name="dcs_postgresql_recovery_conf"></a>`dcs_postgresql_recovery_conf`

Data type: `Hash`

Refer to Patroni Dynamic Configuration Settings `postgresql_recovery_conf` setting

Default value: `{}`

##### <a name="dcs_postgresql_parameters"></a>`dcs_postgresql_parameters`

Data type: `Hash`

Refer to Patroni Dynamic Configuration Settings `postgresql_parameters` setting

Default value: `{}`

##### <a name="bootstrap_method"></a>`bootstrap_method`

Data type: `String[1]`

Refer to Bootstrap configuration settings `method` setting

Default value: `'initdb'`

##### <a name="initdb_data_checksums"></a>`initdb_data_checksums`

Data type: `Boolean`

Refer to Bootstrap configuration settings `data-checksums` setting

Default value: ``true``

##### <a name="initdb_encoding"></a>`initdb_encoding`

Data type: `String`

Refer to Bootstrap configuration settings `encoding` setting

Default value: `'UTF8'`

##### <a name="initdb_locale"></a>`initdb_locale`

Data type: `String`

Refer to Bootstrap configuration settings `locale` setting

Default value: `'en_US.utf8'`

##### <a name="bootstrap_pg_hba"></a>`bootstrap_pg_hba`

Data type: `Array[String]`

Refer to Bootstrap configuration settings `pg_hba` setting

Default value: `[
    'host all all 0.0.0.0/0 md5',
    'host replication rep_user 0.0.0.0/0 md5',
  ]`

##### <a name="bootstrap_users"></a>`bootstrap_users`

Data type: `Hash`

Refer to Bootstrap configuration settings `users` setting

Default value: `{}`

##### <a name="bootstrap_post_bootstrap"></a>`bootstrap_post_bootstrap`

Data type: `Variant[Undef,String]`

Refer to Bootstrap configuration settings `post_bootstrap` setting

Default value: ``undef``

##### <a name="bootstrap_post_init"></a>`bootstrap_post_init`

Data type: `Variant[Undef,String]`

Refer to Bootstrap configuration settings `post_init` setting

Default value: ``undef``

##### <a name="superuser_username"></a>`superuser_username`

Data type: `String`

Refer to PostgreSQL configuration settings superuser username

Default value: `'postgres'`

##### <a name="superuser_password"></a>`superuser_password`

Data type: `String`

Refer to PostgreSQL configuration settings superuser password

Default value: `'changeme'`

##### <a name="replication_username"></a>`replication_username`

Data type: `String`

Refer to PostgreSQL configuration settings replication username

Default value: `'rep_user'`

##### <a name="replication_password"></a>`replication_password`

Data type: `String`

Refer to PostgreSQL configuration settings replication password

Default value: `'changeme'`

##### <a name="callback_on_reload"></a>`callback_on_reload`

Data type: `Variant[Undef,String]`

Refer to PostgreSQL configuration settings callbacks `on_reload`

Default value: ``undef``

##### <a name="callback_on_restart"></a>`callback_on_restart`

Data type: `Variant[Undef,String]`

Refer to PostgreSQL configuration settings callbacks `on_restart`

Default value: ``undef``

##### <a name="callback_on_role_change"></a>`callback_on_role_change`

Data type: `Variant[Undef,String]`

Refer to PostgreSQL configuration settings callbacks `on_role_change`

Default value: ``undef``

##### <a name="callback_on_start"></a>`callback_on_start`

Data type: `Variant[Undef,String]`

Refer to PostgreSQL configuration settings callbacks `on_start`

Default value: ``undef``

##### <a name="callback_on_stop"></a>`callback_on_stop`

Data type: `Variant[Undef,String]`

Refer to PostgreSQL configuration settings callbacks `on_stop`

Default value: ``undef``

##### <a name="pgsql_connect_address"></a>`pgsql_connect_address`

Data type: `String`

Refer to PostgreSQL configuration settings `connect_address` setting

Default value: `"${facts['networking']['fqdn']}:5432"`

##### <a name="pgsql_create_replica_methods"></a>`pgsql_create_replica_methods`

Data type: `Array[String]`

Refer to PostgreSQL configuration settings `create_replica_methods` setting

Default value: `['basebackup']`

##### <a name="pgsql_data_dir"></a>`pgsql_data_dir`

Data type: `Optional[Stdlib::Unixpath]`

Refer to PostgreSQL configuration settings `data_dir` setting

Default value: ``undef``

##### <a name="pgsql_config_dir"></a>`pgsql_config_dir`

Data type: `Variant[Undef,String]`

Refer to PostgreSQL configuration settings `config_dir` setting

Default value: ``undef``

##### <a name="pgsql_bin_dir"></a>`pgsql_bin_dir`

Data type: `Variant[Undef,String]`

Refer to PostgreSQL configuration settings `bin_dir` setting

Default value: ``undef``

##### <a name="pgsql_listen"></a>`pgsql_listen`

Data type: `String`

Refer to PostgreSQL configuration settings `listen` setting

Default value: `'0.0.0.0:5432'`

##### <a name="pgsql_use_unix_socket"></a>`pgsql_use_unix_socket`

Data type: `Boolean`

Refer to PostgreSQL configuration settings `use_unix_socket` setting

Default value: ``false``

##### <a name="pgsql_pgpass_path"></a>`pgsql_pgpass_path`

Data type: `String`

Refer to PostgreSQL configuration settings `pgpass_path` setting

Default value: `'/tmp/pgpass0'`

##### <a name="pgsql_recovery_conf"></a>`pgsql_recovery_conf`

Data type: `Hash`

Refer to PostgreSQL configuration settings `recovery_conf` setting

Default value: `{}`

##### <a name="pgsql_custom_conf"></a>`pgsql_custom_conf`

Data type: `Variant[Undef,String]`

Refer to PostgreSQL configuration settings `custom_conf` setting

Default value: ``undef``

##### <a name="pgsql_parameters"></a>`pgsql_parameters`

Data type: `Hash`

Refer to PostgreSQL configuration settings `parameters` setting

Default value: `{}`

##### <a name="pgsql_pg_hba"></a>`pgsql_pg_hba`

Data type: `Array[String]`

Refer to PostgreSQL configuration settings `pg_hba` setting

Default value: `[]`

##### <a name="pgsql_pg_ctl_timeout"></a>`pgsql_pg_ctl_timeout`

Data type: `Integer`

Refer to PostgreSQL configuration settings `pg_ctl_timeout` setting

Default value: `60`

##### <a name="pgsql_use_pg_rewind"></a>`pgsql_use_pg_rewind`

Data type: `Boolean`

Refer to PostgreSQL configuration settings `use_pg_rewind` setting

Default value: ``true``

##### <a name="pgsql_remove_data_directory_on_rewind_failure"></a>`pgsql_remove_data_directory_on_rewind_failure`

Data type: `Boolean`

Refer to PostgreSQL configuration settings `remove_data_directory_on_rewind_failure` setting

Default value: ``false``

##### <a name="pgsql_replica_method"></a>`pgsql_replica_method`

Data type: `Array[Hash]`

Refer to PostgreSQL configuration settings `replica_method` setting

Default value: `[]`

##### <a name="manage_postgresql_repo"></a>`manage_postgresql_repo`

Data type: `Boolean`

Should the postgresql module manage the package repo

Default value: ``true``

##### <a name="use_consul"></a>`use_consul`

Data type: `Boolean`

Boolean to use Consul for configuration storage

Default value: ``false``

##### <a name="consul_host"></a>`consul_host`

Data type: `String`

Refer to Consul configuration `host` setting

Default value: `'localhost'`

##### <a name="consul_url"></a>`consul_url`

Data type: `Variant[Undef,String]`

Refer to Consul configuration `url` setting

Default value: ``undef``

##### <a name="consul_port"></a>`consul_port`

Data type: `Stdlib::Port`

Refer to Consul configuration `port` setting

Default value: `8500`

##### <a name="consul_scheme"></a>`consul_scheme`

Data type: `Enum['http','https']`

Refer to Consul configuration `scheme` setting

Default value: `'http'`

##### <a name="consul_token"></a>`consul_token`

Data type: `Variant[Undef,String]`

Refer to Consul configuration `token` setting

Default value: ``undef``

##### <a name="consul_verify"></a>`consul_verify`

Data type: `Boolean`

Refer to Consul configuration `verify` setting

Default value: ``false``

##### <a name="consul_register_service"></a>`consul_register_service`

Data type: `Optional[Boolean]`

Refer to Consul configuration `register_service` setting

Default value: ``undef``

##### <a name="consul_service_check_interval"></a>`consul_service_check_interval`

Data type: `Optional[String]`

Refer to Consul configuration `service_check_interval` setting

Default value: ``undef``

##### <a name="consul_consistency"></a>`consul_consistency`

Data type: `Optional[Enum['default', 'consistent', 'stale']]`

Refer to Consul configuration `consistency` setting

Default value: ``undef``

##### <a name="consul_cacert"></a>`consul_cacert`

Data type: `Variant[Undef,String]`

Refer to Consul configuration `cacert` setting

Default value: ``undef``

##### <a name="consul_cert"></a>`consul_cert`

Data type: `Variant[Undef,String]`

Refer to Consul configuration `cert` setting

Default value: ``undef``

##### <a name="consul_key"></a>`consul_key`

Data type: `Variant[Undef,String]`

Refer to Consul configuration `key` setting

Default value: ``undef``

##### <a name="consul_dc"></a>`consul_dc`

Data type: `Variant[Undef,String]`

Refer to Consul configuration `dc` setting

Default value: ``undef``

##### <a name="consul_checks"></a>`consul_checks`

Data type: `Variant[Undef,String]`

Refer to Consul configuration `checks` setting

Default value: ``undef``

##### <a name="use_etcd"></a>`use_etcd`

Data type: `Boolean`

Boolean to use Etcd for configuration storage

Default value: ``false``

##### <a name="etcd_host"></a>`etcd_host`

Data type: `String`

Refer to Etcd configuration `host` setting

Default value: `'127.0.0.1:2379'`

##### <a name="etcd_hosts"></a>`etcd_hosts`

Data type: `Array[String]`

Refer to Etcd configuration `hosts` setting

Default value: `[]`

##### <a name="etcd_url"></a>`etcd_url`

Data type: `Variant[Undef,String]`

Refer to Etcd configuration `url` setting

Default value: ``undef``

##### <a name="etcd_proxyurl"></a>`etcd_proxyurl`

Data type: `Variant[Undef,String]`

Refer to Etcd configuration `proxy` setting

Default value: ``undef``

##### <a name="etcd_srv"></a>`etcd_srv`

Data type: `Variant[Undef,String]`

Refer to Etcd configuration `srv` setting

Default value: ``undef``

##### <a name="etcd_protocol"></a>`etcd_protocol`

Data type: `Enum['http','https']`

Refer to Etcd configuration `protocol` setting

Default value: `'http'`

##### <a name="etcd_username"></a>`etcd_username`

Data type: `Variant[Undef,String]`

Refer to Etcd configuration `username` setting

Default value: ``undef``

##### <a name="etcd_password"></a>`etcd_password`

Data type: `Variant[Undef,String]`

Refer to Etcd configuration `password` setting

Default value: ``undef``

##### <a name="etcd_cacert"></a>`etcd_cacert`

Data type: `Variant[Undef,String]`

Refer to Etcd configuration `cacert` setting

Default value: ``undef``

##### <a name="etcd_cert"></a>`etcd_cert`

Data type: `Variant[Undef,String]`

Refer to Etcd configuration `cert` setting

Default value: ``undef``

##### <a name="etcd_key"></a>`etcd_key`

Data type: `Variant[Undef,String]`

Refer to Etcd configuration `key` setting

Default value: ``undef``

##### <a name="use_exhibitor"></a>`use_exhibitor`

Data type: `Boolean`

Boolean to use Exhibitor configuration storage

Default value: ``false``

##### <a name="exhibitor_hosts"></a>`exhibitor_hosts`

Data type: `Array[String]`

Refer to Exhibitor configuration `hosts` setting

Default value: `[]`

##### <a name="exhibitor_poll_interval"></a>`exhibitor_poll_interval`

Data type: `Integer`

Refer to Exhibitor configuration `poll_interval` setting

Default value: `10`

##### <a name="exhibitor_port"></a>`exhibitor_port`

Data type: `Integer`

Refer to Exhibitor configuration `port` setting

Default value: `8080`

##### <a name="use_kubernetes"></a>`use_kubernetes`

Data type: `Boolean`

Boolean to use Kubernetes configuration storage

Default value: ``false``

##### <a name="kubernetes_namespace"></a>`kubernetes_namespace`

Data type: `String`

Refer to Kubernetes configuration `namespace` setting

Default value: `'default'`

##### <a name="kubernetes_labels"></a>`kubernetes_labels`

Data type: `Hash`

Refer to Kubernetes configuration `labels` setting

Default value: `{}`

##### <a name="kubernetes_scope_label"></a>`kubernetes_scope_label`

Data type: `Variant[Undef,String]`

Refer to Kubernetes configuration `scope_label` setting

Default value: ``undef``

##### <a name="kubernetes_role_label"></a>`kubernetes_role_label`

Data type: `Variant[Undef,String]`

Refer to Kubernetes configuration `role_label` setting

Default value: ``undef``

##### <a name="kubernetes_use_endpoints"></a>`kubernetes_use_endpoints`

Data type: `Boolean`

Refer to Kubernetes configuration `use_endpoints` setting

Default value: ``false``

##### <a name="kubernetes_pod_ip"></a>`kubernetes_pod_ip`

Data type: `Variant[Undef,String]`

Refer to Kubernetes configuration `pod_ip` setting

Default value: ``undef``

##### <a name="kubernetes_ports"></a>`kubernetes_ports`

Data type: `Variant[Undef,String]`

Refer to Kubernetes configuration `ports` setting

Default value: ``undef``

##### <a name="restapi_ciphers"></a>`restapi_ciphers`

Data type: `Optional[String]`

Refer to REST API configuration `ciphers` setting

Default value: ``undef``

##### <a name="restapi_connect_address"></a>`restapi_connect_address`

Data type: `String`

Refer to REST API configuration `connect_address` setting

Default value: `"${facts['networking']['fqdn']}:8008"`

##### <a name="restapi_listen"></a>`restapi_listen`

Data type: `String`

Refer to REST API configuration `listen` setting

Default value: `'0.0.0.0:8008'`

##### <a name="restapi_username"></a>`restapi_username`

Data type: `Variant[Undef,String]`

Refer to REST API configuration `username` setting

Default value: ``undef``

##### <a name="restapi_password"></a>`restapi_password`

Data type: `Variant[Undef,String]`

Refer to REST API configuration `password` setting

Default value: ``undef``

##### <a name="restapi_certfile"></a>`restapi_certfile`

Data type: `Variant[Undef,String]`

Refer to REST API configuration `certfile` setting

Default value: ``undef``

##### <a name="restapi_keyfile"></a>`restapi_keyfile`

Data type: `Variant[Undef,String]`

Refer to REST API configuration `keyfile` setting

Default value: ``undef``

##### <a name="restapi_cafile"></a>`restapi_cafile`

Data type: `Optional[String]`

Refer to REST API configuration `cafile` setting

Default value: ``undef``

##### <a name="restapi_verify_client"></a>`restapi_verify_client`

Data type: `Optional[Enum['none','optional','required']]`

Refer to REST API configuration `verify_client` setting

Default value: ``undef``

##### <a name="use_zookeeper"></a>`use_zookeeper`

Data type: `Boolean`

Boolean to enable Zookeeper configuration storage

Default value: ``false``

##### <a name="zookeeper_hosts"></a>`zookeeper_hosts`

Data type: `Array[String]`

Refer to Zookeeper configuration `hosts` setting

Default value: `[]`

##### <a name="watchdog_mode"></a>`watchdog_mode`

Data type: `Enum['off','automatic','required']`

Refer to Watchdog configuration `mode` setting

Default value: `'automatic'`

##### <a name="watchdog_device"></a>`watchdog_device`

Data type: `String`

Refer to Watchdog configuration `device` setting

Default value: `'/dev/watchdog'`

##### <a name="watchdog_safety_margin"></a>`watchdog_safety_margin`

Data type: `Integer`

Refer to Watchdog configuration `safety_margin` setting

Default value: `5`

##### <a name="manage_postgresql"></a>`manage_postgresql`

Data type: `Boolean`

Boolean to determine if postgresql is managed

Default value: ``true``

##### <a name="postgresql_version"></a>`postgresql_version`

Data type: `Optional[String]`

Version of postgresql passed to postgresql::globals class

Default value: ``undef``

##### <a name="package_name"></a>`package_name`

Data type: `String`

Patroni package name, only used when `install_method` is `package`

Default value: `'patroni'`

##### <a name="version"></a>`version`

Data type: `String`

Version of Patroni to install

Default value: `'present'`

##### <a name="install_dependencies"></a>`install_dependencies`

Data type: `Array`

Install dependencies, only used when `install_method` is `pip`

Default value: `[]`

##### <a name="manage_python"></a>`manage_python`

Data type: `Boolean`

Manage Python class, only used when `install_method` is `pip`

Default value: ``true``

##### <a name="install_method"></a>`install_method`

Data type: `Enum['package','pip']`

Install method

Default value: `'pip'`

##### <a name="install_dir"></a>`install_dir`

Data type: `Stdlib::Absolutepath`

Install directory, only used when `install_method` is `pip`

Default value: `'/opt/app/patroni'`

##### <a name="python_class_version"></a>`python_class_version`

Data type: `String`

The  version of Python to pass to Python class
Only used when `install_method` is `pip`

Default value: `'36'`

##### <a name="python_venv_version"></a>`python_venv_version`

Data type: `String`

The  version of Python to pass to Python virtualenv defined type
Only used when `install_method` is `pip`

Default value: `'3.6'`

##### <a name="config_path"></a>`config_path`

Data type: `String`

Path to Patroni configuration file

Default value: `'/opt/app/patroni/etc/postgresql.yml'`

##### <a name="config_owner"></a>`config_owner`

Data type: `String`

Patroni configuration file owner

Default value: `'postgres'`

##### <a name="config_group"></a>`config_group`

Data type: `String`

Patroni configuration file group

Default value: `'postgres'`

##### <a name="config_mode"></a>`config_mode`

Data type: `String`

Patroni configuration file mode

Default value: `'0600'`

##### <a name="service_name"></a>`service_name`

Data type: `String`

Name of Patroni service

Default value: `'patroni'`

##### <a name="service_ensure"></a>`service_ensure`

Data type: `String`

Patroni service ensure property

Default value: `'running'`

##### <a name="service_enable"></a>`service_enable`

Data type: `Boolean`

Patroni service enable property

Default value: ``true``

##### <a name="custom_pip_provider"></a>`custom_pip_provider`

Data type: `Optional[String[1]]`

Use custom pip path when installing pip packages

Default value: ``undef``

## Resource types

### <a name="patroni_dcs_config"></a>`patroni_dcs_config`

Manages Patroni DCS configuration options

#### Examples

##### Set PostgreSQL max connections

```puppet
patroni_dcs_config { 'postgresql.params.max_connections':
  value => '200',
}
```

#### Properties

The following properties are available in the `patroni_dcs_config` type.

##### `value`

The value to assign the DCS configuration

#### Parameters

The following parameters are available in the `patroni_dcs_config` type.

* [`name`](#name)
* [`provider`](#provider)

##### <a name="name"></a>`name`

namevar

The DCS configuration option name

##### <a name="provider"></a>`provider`

The specific backend to use for this `patroni_dcs_config` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="patronictl_config"></a>`patronictl_config`

**NOTE** This is a private type not intended to be used directly.

#### Parameters

The following parameters are available in the `patronictl_config` type.

* [`config`](#config)
* [`name`](#name)
* [`path`](#path)

##### <a name="config"></a>`config`

patronictl config

Default value: `/opt/app/patroni/etc/postgresql.yml`

##### <a name="name"></a>`name`

namevar

The name of the resource.

##### <a name="path"></a>`path`

patronictl path

Default value: `/opt/app/patroni/bin/patronictl`

